#- hosts: cloud.dfaserver.*
- hosts: cloud.provenance.*
  prepare:
    - copy:
        src: "{{ working_dir }}/fake_server.py"
        dest: "/tmp/fake_server.py"
    - copy:
        src: "{{ working_dir }}/create-dataflow-specification-dfanalyzer.py"
        dest: "/tmp/create-dataflow-specification-dfanalyzer.py"
#    - copy:
#        src: "{{ working_dir }}/server_coap.py"
#        dest: "/tmp/server_coap.py"
    - copy:
        src: "{{ working_dir }}/server_mqttsn.py"
        dest: "/tmp/server_mqttsn.py"
    - copy:
        src: "{{ working_dir }}/server_mqttsn_translator.py"
        dest: "/tmp/server_mqttsn_translator.py"
#    - copy:
#        src: "{{ working_dir }}/client_mqttsn_v6.py"
#        dest: "~/mqttsn/src/mqttsn/client.py"
    - copy:
        src: "{{ working_dir }}/config.conf"
        dest: "~/mosquitto.rsmb/rsmb/src/config.conf"
  launch:
    - debug:
#        msg: "Running CoAP at: http://{{ _self.url }}/, coap://[{{ _self.__address6__ }}]:5683"
        msg: "Running..."
    - shell: ls
#    - shell: python3 /tmp/fake_server.py
#    - shell: ./root/mosquitto.rsmb/rsmb/src/broker_mqtts config.conf
#    - shell: python3 /tmp/server_mqttsn.py
#    - debug:
#        msg: "[{{ lookup('pipe','date +%Y-%m-%d-%H-%M-%S') }}] Pulling Dfanalyzer docker image"
#    - shell: docker pull vitorss/dataflow_analyzer
#    - shell: docker run -d --rm -p 22000:22000 --name dfserver -it vitorss/dataflow_analyzer
#  launch:
#    - debug:
#        msg: "Starting Dfanalyzer server"
#    - shell: docker exec -it -d dfserver bash -c "cd dfanalyzer/applications/dfanalyzer/ && ./start-dfanalyzer.sh"
#  finalize:
#    - debug:
#        msg: "Stopping Dfanalyzer server"
#    - shell: docker container stop dfserver
- hosts: edge.dfaclient.*
#  depends_on:
#    service_selector: "cloud.dfaserver.*"
#    grouping: "round_robin"
#    prefix: "dfaserver"
  prepare:
#    - debug:
#        msg: "[{{ lookup('pipe','date +%Y-%m-%d-%H-%M-%S') }}] Preparing client, server at: http://{{ dfaserver.url }}/, http://{{ dfaserver.url4 }}/, http://{{ dfaserver.url6 }}/"
#    - copy:
#        src: "{{ working_dir }}/synthetic-workload-baseline.py"
#        dest: "/tmp/synthetic-workload-baseline.py"
    - copy:
        src: "{{ working_dir }}/synthetic-workload-dfanalyzer.py"
        dest: "/tmp/synthetic-workload-dfanalyzer.py"
#    - copy:
#        src: "{{ working_dir }}/synthetic-workload-provlake.py"
#        dest: "/tmp/synthetic-workload-provlake.py"
    - copy:
        src: "{{ working_dir }}/synthetic-workload-provlight.py"
        dest: "/tmp/synthetic-workload-provlight.py"
#    - copy:
#        src: "{{ working_dir }}/synthetic-workload-prov_coap.py"
#        dest: "/tmp/synthetic-workload-prov_coap.py"
#    - copy:
#        src: "{{ working_dir }}/synthetic-workload-prov_mqttsn.py"
#        dest: "/tmp/synthetic-workload-prov_mqttsn.py"
#    - copy:
#        src: "{{ working_dir }}/task.py"
#        dest: "~/dfa-lib-python/dfa_lib_python/task.py"
#    - copy:
#        src: "{{ working_dir }}/client_mqttsn_v6.py"
#        dest: "/usr/lib/python3.8/site-packages/mqttsn/client.py"
#        dest: "~/mqttsn/src/mqttsn/client.py"
  launch:
    - debug:
        msg: "Running client, server at: http://{{ dfaserver.url }}/, http://{{ dfaserver.url4 }}/, http://{{ dfaserver.url6 }}/"
    - shell: python /tmp/synthetic-workload-baseline.py --number_of_tasks 100 --data_values_per_task 100 --task_duration 1 --log /tmp/client-out-v2.log
#    - shell: export PROVLAKE_URL=http://{{ dfaserver.url6 }} && python /tmp/synthetic-workload-provlake.py --number_of_transformations 5 --number_of_tasks 100 --data_values_per_task 100 --task_dur>
#    - shell: export DFA_URL=http://{{ dfaserver.url6 }} && python /tmp/synthetic-workload-dfanalyzer.py --number_of_transformations 5 --number_of_tasks 100 --data_values_per_task 100 --task_durati>
#    - shell: export PROVLIGHT_SERVER_URL={{ dfaserver.__address6__ }} && python /tmp/synthetic-workload-provlight.py --number_of_transformations 5 --number_of_tasks 100 --data_values_per_task 100 >
#
#    - shell: export DFA_URL=http://{{ dfaserver.url6 }}/ && python /tmp/synthetic-workload-prov.py --number_of_transformations 5 --number_of_tasks 100 --data_values_per_task 100 --task_duration 0.>
#    - shell: export DFA_URL_COAP=coap://[{{ dfaserver.__address6__ }}]:5683 && export DFA_URL=http://{{ dfaserver.url6 }}/ && python /tmp/synthetic-workload-prov_light.py --number_of_transformatio>
  finalize:
    - debug:
        msg: "Saving results"
    - fetch:
        src: "/tmp/client-out-v2.log"
        dest: "{{ working_dir }}/experiment-results/"
        validate_checksum: no
